package com.ibm.mqe.model;

/****************************************************************************/
/*                                                                          */
/* Program name: MQ Series Everyplace - Administration Tool                 */
/*                                                                          */
/*  Statement:  Licensed Materials - Property of IBM                        */
/*                                                                          */
/*              MQSeries SupportPac MSE1                                    */
/*              (C) Copyright IBM Corp. 2000                                */
/*                                                                          */
/****************************************************************************/
/*                                                                          */
/* Change history:                                                          */
/*                                                                          */
/* V1.0   15-08-2000  PTvL  Initial release                                 */
/*                                                                          */
/*==========================================================================*/
import com.ibm.uia.metamodel.*;
import com.ibm.mqe.*;
import java.util.*;

/**
 * This type represents an entity that has very little behaviour
 * and no children.  Its behaviour is controlled almost entirely
 * by its parent.
 * This type represents all Alii ('aliases'), and QueueManager 
 * entries in StoreAndForwardQueues.
 * Creation date: (02/07/2000 14:02:03)
 * @author: Phill van Leersum
 */
public final class MQeFieldObject extends CreatableObject {
	MQeField mqeField;
protected ManagedObject _realParent() {
	UIObject parent = getParent();
	while (null != parent) {
		if (parent instanceof ManagedObject) {
			return (ManagedObject)parent;
		}
		parent = parent.getParent();
	}
	return null;
}
void setField(MQeField f) {
	mqeField = f;
	try {
		String fieldValue = f.unTypedObject().toString();
		setAttribute("value", fieldValue);
	} catch (Exception e) {
	}
}
}
