package com.ibm.mqe.model;

/****************************************************************************/
/*                                                                          */
/* Program name: MQ Series Everyplace - Administration Tool                 */
/*                                                                          */
/*  Statement:  Licensed Materials - Property of IBM                        */
/*                                                                          */
/*              MQSeries SupportPac MSE1                                    */
/*              (C) Copyright IBM Corp. 2000                                */
/*                                                                          */
/****************************************************************************/
/*                                                                          */
/* Change history:                                                          */
/*                                                                          */
/* V1.0   15-08-2000  PTvL  Initial release                                 */
/*                                                                          */
/*==========================================================================*/
import com.ibm.uia.renderingInterface.*;
import com.ibm.uia.metamodel.*;
import java.util.*;
import com.ibm.uia.xml.*;
import com.ibm.mqe.*;
import java.util.zip.*;

/**
 * This type was created in VisualAge.
 */
public class MQeMetaModel extends MetaModel implements MQeMetaModelConstants {
	protected static String DefaultModelName = "mqeMetaModel.xml";
	protected static String DefaultJarName = "mqeExplorer.jar";
/**
 * MQMetaModel constructor comment.
 * @param element org.w3c.dom.Element
 */
public MQeMetaModel() {
	super();
}
/**
 * Insert the method's description here.
 * Creation date: (27/07/2000 12:12:17)
 * @param args java.lang.String[]
 */
public static void main(String[] args) {
	mainProcess(args);
}
/**
 * Separate the processing from the main method, so we can call it
 * from subclass main....
 * @param args java.lang.String[]
 */
public static void mainProcess(String[] args) {
	String port = "8088";
	String queueManagerName = "AdministeringQM";
	String modelName = DefaultModelName;
	String resourceName = DefaultJarName;
	boolean usePopupMenus = true;
	boolean useSelectedMenus = true;
	int i = 0;
	while (i < args.length){
		String arg = args[i];
		if ("-smenu".equals(arg)) {
			useSelectedMenus = false;
		} else if ("-pmenu".equals(arg)) {
			usePopupMenus = false;
		} else if ("/model".equals(arg)) {
			if (args.length > i) {
				i++;
				modelName = args[i];
			}
		} else if ("/name".equals(arg)) {
			if (args.length > i) {
				i++;
				queueManagerName = args[i];
			}
		} else if ("/port".equals(arg)) {
			if (args.length > i) {
				i++;
				port = args[i];
			}
		} else if ("/resource".equals(arg)) {
			if (args.length > i) {
				i++;
				resourceName = args[i];
			}
		} else {
			System.out.println("Inalid Argument: " + args[i]);
			System.out.println("\nValid Arguments:");
			System.out.println("   /model modelName      The metamodel file to use (default is mqeMetaModel.xml)");
			System.out.println("   /name  qmName         The name for the administering qm (default is AdministeringQM)");
			System.out.println("   /port  portnumber     The port to listen on (default is 8088)");
			System.out.println("   /resource fileName    The name of file containing resources (default is images.jar)");
			System.out.println("   -pmenu				 Disable popup menus (default is enabled)");
			System.out.println("   -smenu				 Disable 'selected' menus (default is enabled)");
		}
		i++;
	}
	setResourceFileName(resourceName);
	com.ibm.uia.renderer.RendererImplementation renderer = new com.ibm.uia.renderer.RendererImplementation();
	renderer.setBounds(10,10,610, 450);
	renderer.usePopupMenu(usePopupMenus);
	renderer.useSelectedMenu(useSelectedMenus);
	renderer.show();
	MQeAdminUtils.setReporter(renderer);
	renderer._comment("/model " + modelName + "/name " + queueManagerName + " /port " + port);
	
	MQeMetaModel metaModel = null;
	try {
		ZipFile zipFile = new ZipFile(resourceName);
		ZipEntry zipEntry = zipFile.getEntry(modelName);
		Document doc = Parser.Parse(new java.io.InputStreamReader(zipFile.getInputStream(zipEntry)));
		metaModel =  (MQeMetaModel)From(doc.getDocumentElement());
	} catch (Exception e) {
		renderer._comment("failed to read " + modelName + " from " + resourceName);
	}
	if (null == metaModel) {
		renderer._comment("Reading " + modelName + " from disk");
		metaModel = (MQeMetaModel)FromFile(modelName);
	}
	
	if (null == metaModel) {
		renderer._error("Failed to parse metamodel " + modelName);
	} else {
		renderer.addModel(metaModel.newRootObject(queueManagerName, port));
	}
}
/**
 * Create a new metaObject for the receiver.
 * Subclasses of MetaModel can overide this to create
 * instances of their own subclasses of MetaObject
 */
protected MetaObject newMetaObject() {
	return new MQeMetaObject(this);
}
public RenderableObject newRootObject(String qmName, String port) {
	MQeModel model = null;
	QueueManagerWrapper qmw = new QueueManagerWrapper(qmName, port);
	qmw.start();
	MQeQueueManager qm = qmw.getQueueManager();
	if (null == qm) {
		System.out.println("null qm");
		(new Exception()).printStackTrace();
	}
	//MQeAdministeringQM adminQM = new MQeAdministeringQM(qmName, port);
	//adminQM.start();
	//if (!adminQM.isValid()) {
		//MQeAdminUtils._comment("failed to create administering QM");
	//} else {
		model = (MQeModel)super. newRootObject();
		model.setAdminQM(qm);
		model._addQMDirect(null, qmName);
		
	//}
	return model;
}
}
