package com.ibm.uia.metamodel;

/****************************************************************************/
/*                                                                          */
/* Program name: MQ Series Everyplace - Administration Tool                 */
/*                                                                          */
/*  Statement:  Licensed Materials - Property of IBM                        */
/*                                                                          */
/*              MQSeries SupportPac MSE1                                    */
/*              (C) Copyright IBM Corp. 2000                                */
/*                                                                          */
/****************************************************************************/
/*                                                                          */
/* Change history:                                                          */
/*                                                                          */
/* V1.0   15-08-2000  PTvL  Initial release                                 */
/*                                                                          */
/*==========================================================================*/
import com.ibm.uia.renderingInterface.*;
import com.ibm.uia.metamodel.*;
import com.ibm.uia.xml.*;
import java.awt.Color;
import java.awt.datatransfer.*;
import java.io.*;
import java.util.*;
/**
 * This type was created in VisualAge.
 */
public class ExampleObject extends UIObject {
	protected static final String CMD_DELETE = "Delete";
	protected static final String CMD_COPY = "Copy";
	protected static final String CMD_CUT = "Cut";
	protected static final String CMD_PASTE = "Paste";
	protected static final String CMD_EDIT_ATTRIBUTES = "Edit Attributes";
/**
 * TestObject constructor comment.
 */
public ExampleObject() {
	super();
}
/**
 * Perform the actions represented by the supplied instance of 
 * <code>RenderableOperation</code> defined in te metamodel file.
 * If the operation was defined with a prompt then the String array
 * will be non-null, and will contain a string for every line of the prompt
 *
 * The renderer responsible for delivering the operation request is passed in
 * for convenience.
 *
 * Reply true if a stuctural refresh is reqired.
 */
public boolean performOperation(RenderableOperation op, Renderer renderer) {
	String[] data = op.getData();
	String command = op.getName();
	boolean reply = false;
	if (isValidChildType(command)) {
		String name = command;
		if (null != data && data.length > 0 && data[0] != null) {
			name = data[0];
		}
		addNewChild(command, name);
		return true;
	} else {
		reply = super.performOperation(op, renderer);
	}
	return reply;
}
}
