package com.ibm.uia.metamodel;

/****************************************************************************/
/*                                                                          */
/* Program name: MQ Series Everyplace - Administration Tool                 */
/*                                                                          */
/*  Statement:  Licensed Materials - Property of IBM                        */
/*                                                                          */
/*              MQSeries SupportPac MSE1                                    */
/*              (C) Copyright IBM Corp. 2000                                */
/*                                                                          */
/****************************************************************************/
/*                                                                          */
/* Change history:                                                          */
/*                                                                          */
/* V1.0   15-08-2000  PTvL  Initial release                                 */
/*                                                                          */
/*==========================================================================*/
import com.ibm.uia.xml.*;
/**
 * This type was created in VisualAge.
 */
public class StringType extends AttributeType {
	public static final String MAXLENGTH = "maxLength";
	public static final String MAXLENGTH_VALUE = "value";
	private int maxLength = 256;
/**
 * StringType constructor comment.
 */
public StringType(MetaModel metaModel) {
	super(metaModel);
}
/**
 * create a DOM representation of the receiver using
 * the supplied document.  The Element generated should
 * be returned to the caller, and not appended to the 
 * document.  Subclasses can override this method but
 * are strongly recommended to call the superclass
 * method FIRST and decorate the returned element with their
 * specific data.
 * Note that the superclass is responsible for navigating
 * the standard tree structures, so this responsibility
 * is removed from subclass implementors
 */
protected Element generateDom(Document doc) {
	Element el = super.generateDom(doc);
	el.setAttribute(ATTRIBUTE_TYPE_MODE, STRING_MODE);
	
	Element child = doc.createElement(MAXLENGTH);
	child.setAttribute(MAXLENGTH_VALUE, ""+ maxLength);
	el.appendChild(child);
	return el;
}
public int getMaxLength() {
	return maxLength;
}
/**
 * isStringType method comment.
 */
public final boolean isStringType() {
	return true;
}
public final boolean isValid(String str) {
	return str.length() <= maxLength;
}
/**
 * Initialise a child of the receiver from the given Element.
 */ 
protected final UIAComponent parseChildElement(Element elem) {
	String elemName = elem.getNodeName();
	if (MAXLENGTH.equals(elemName)) {
		String strLen = elem.getAttribute(MAXLENGTH_VALUE);
		maxLength = Integer.parseInt(strLen.trim());
	} else {
		super.parseChildElement(elem);
	}
	return this;
}
public void setMaxLength(int i) {
	maxLength = i;
}
public final String validate(String str) {
	if (str.length() <= maxLength) {
		return str;
	}
	return str.substring(0, maxLength);
}
}
