package com.ibm.uia.renderer;

/****************************************************************************/
/*                                                                          */
/* Program name: MQ Series Everyplace - Administration Tool                 */
/*                                                                          */
/*  Statement:  Licensed Materials - Property of IBM                        */
/*                                                                          */
/*              MQSeries SupportPac MSE1                                    */
/*              (C) Copyright IBM Corp. 2000                                */
/*                                                                          */
/****************************************************************************/
/*                                                                          */
/* Change history:                                                          */
/*                                                                          */
/* V1.0   15-08-2000  PTvL  Initial release                                 */
/*                                                                          */
/*==========================================================================*/
import java.util.*;

import java.awt.*;
import java.awt.event.*;
import com.ibm.uia.renderingInterface.*;

/**
 * This type was created in VisualAge.
 */
public class RendererObjectNode extends RendererNode {
	
	// the renderable object represented by this node
	protected RenderableObject renderableObject;
public RendererObjectNode(RenderableObject renderableObject) {
	super();
	this.renderableObject = renderableObject;
}
/**
 * reply the colour for rendering the text
 */
protected Color _getDisplayColour() {
	return renderableObject.getDisplayColour();
}
protected Image _getImage() {
	return renderableObject.getCaptionImage();
}
protected String _getText() {
	return renderableObject.getCaptionText();
}
public boolean copy() {
	return renderableObject.copy();
}
public boolean cut() {
	return renderableObject.cut();
}
final String getHintText() {
	return renderableObject.getHintText(); 
}
PopupMenu getPopupMenu(Renderer renderer) {
	Enumeration enum = renderableObject.getAllOperations();
	OperationsPopupMenu popup = null;
	if (enum.hasMoreElements()) {
		popup = new OperationsPopupMenu("popup");
		while (enum.hasMoreElements()) {
			RenderableOperation rop = (RenderableOperation)enum.nextElement();
			popup.add(rop, renderer);
		}
	}
	return popup;
}
public final RenderableObject getRenderableObject() {
	return renderableObject;
}
Menu getSelectedMenu(Renderer renderer) {
	Enumeration enum = renderableObject.getAllOperations();
	OperationsMenu popup = null;
	if (enum.hasMoreElements()) {
		popup = new OperationsMenu("Selected");
		while (enum.hasMoreElements()) {
			RenderableOperation rop = (RenderableOperation)enum.nextElement();
			popup.add(rop, renderer);
		}
	}
	return popup;
}
public boolean paste() {
	return renderableObject.paste();
}
}
