package com.ibm.uia.renderer;

/****************************************************************************/
/*                                                                          */
/* Program name: MQ Series Everyplace - Administration Tool                 */
/*                                                                          */
/*  Statement:  Licensed Materials - Property of IBM                        */
/*                                                                          */
/*              MQSeries SupportPac MSE1                                    */
/*              (C) Copyright IBM Corp. 2000                                */
/*                                                                          */
/****************************************************************************/
/*                                                                          */
/* Change history:                                                          */
/*                                                                          */
/* V1.0   15-08-2000  PTvL  Initial release                                 */
/*                                                                          */
/*==========================================================================*/
import com.ibm.uia.renderingInterface.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
/**
 * This type was created in VisualAge.
 */
public class SingleAttributeEditPanel extends Panel {
	private static final int EDIT_WIDTH = 20;
	private RenderableAttribute attribute = null;
	private Choice editChoice;
	private TextField editTextField;
/**
 * RenderPanel constructor comment.
 */
public SingleAttributeEditPanel(RenderableAttribute attribute, ActionListener listener) {
	super(new BorderLayout());
	this.attribute = attribute;
	_createEditControl(listener);
}
private final void _createEditControl(ActionListener listener) {
	if (attribute.getType().isEnumeratedType()) {
		editChoice = new Choice();
		Enumeration enum = attribute.getType().getValidValues();
		editChoice.removeAll();
		while (enum.hasMoreElements()) {
			editChoice.add(enum.nextElement().toString());
		}
		editChoice.select(attribute.getValue());
		add(editChoice);
	} else {
		editTextField = new TextField(EDIT_WIDTH);
		editTextField.setText(attribute.getValue());
		editTextField.setEditable(attribute.isEditable());
		editTextField.addActionListener(listener);
		add(editTextField);
	}
}
private final String _getCurrentValue() {
	String str = null;
	if (attribute.isEditable()) {
		if (attribute.getType().isEnumeratedType()) {
			str = editChoice.getSelectedItem();
		} else {
			str = editTextField.getText();
			str = attribute.getType().validate(str);
			editTextField.setText(str);
		}
	}
	return str;
}
private final void _setValues() {
	if (attribute.getType().isEnumeratedType()) {
		editChoice.select(attribute.getValue());
	} else {
		editTextField.setText(attribute.getValue());
	}
}
public void commit() {
	if (attribute.isEditable()) {
		if (attribute.getType().isEnumeratedType()) {
			attribute.setValue(editChoice.getSelectedItem());
		} else {
			String str = editTextField.getText();
			if (null != str) {
				str = attribute.getType().validate(str);
				attribute.setValue(str);
			}
		}
	}
}
public final void resetValues() {
	_setValues();
}
}
