package com.ibm.uia.renderingInterface;

/****************************************************************************/
/*                                                                          */
/* Program name: MQ Series Everyplace - Administration Tool                 */
/*                                                                          */
/*  Statement:  Licensed Materials - Property of IBM                        */
/*                                                                          */
/*              MQSeries SupportPac MSE1                                    */
/*              (C) Copyright IBM Corp. 2000                                */
/*                                                                          */
/****************************************************************************/
/*                                                                          */
/* Change history:                                                          */
/*                                                                          */
/* V1.0   15-08-2000  PTvL  Initial release                                 */
/*                                                                          */
/*==========================================================================*/
import java.util.*;
/**
 * This interface marks a class as renderable.  It gives access to
 * the display items common to all renderables:
 *	-	Caption
 *	-	Hint
 *	-	Help
 * Currently these are returned as strings.  Eventually each will have its 
 * own class......
 */
public interface Renderable {
/**
 * Reply the Image used as an external identifier
 * for the receiver
 */
public abstract java.awt.Image getCaptionImage();
/**
 * Reply the string used as an external identifier
 * for the receiver
 */
public abstract String getCaptionText();
public abstract String getHelpText();
public abstract String getHintText();
/**
 * Reply the string used as an internal identifier
 * for the receiver.  The name is used internally
 * to identify renderable components, and should not 
 * be NLSed
 */
public abstract String getName();
}
