package com.ibm.uia.renderingInterface;

/****************************************************************************/
/*                                                                          */
/* Program name: MQ Series Everyplace - Administration Tool                 */
/*                                                                          */
/*  Statement:  Licensed Materials - Property of IBM                        */
/*                                                                          */
/*              MQSeries SupportPac MSE1                                    */
/*              (C) Copyright IBM Corp. 2000                                */
/*                                                                          */
/****************************************************************************/
/*                                                                          */
/* Change history:                                                          */
/*                                                                          */
/* V1.0   15-08-2000  PTvL  Initial release                                 */
/*                                                                          */
/*==========================================================================*/
import java.util.Enumeration;
/**
 * Insert the type's description here.
 * Creation date: (05/06/2000 09:06:19)
 * @author: Phill van Leersum
 */
public interface Renderer {
public abstract void addModel(RenderableObject model);
public abstract void comment(String commentText);
public abstract void displayMessage(String title, String message);
/**
 * edit the given object if possible.
 * return true if a change was made.
 */
public abstract boolean edit(RenderableObject rend, boolean displayOnlyRequiredAttributes);
public abstract void error(String errorText);
/**
 * Get a load file description from the user.
 * 	title:  dialog title
 *	dir:	name of initial directory  (current directory if null)
 *	filename:	initial name of file	(ignored if null)
 *
 * returns a complete file description
 */
public abstract String getLoadFileName(String title, String dir, String filename);
public abstract	Enumeration getRootObjects();
/**
 * Get a save file description from the user.
 * 	title:  dialog title
 *	dir:	name of initial directory  (current directory if null)
 *	filename:	initial name of file	(ignored if null)
 *
 * returns a complete file description
 */
public abstract String getSaveFileName(String title, String dir, String filename);
public abstract void openNewRenderer(RenderableObject robj);
/**
 * Prompt the user for some strings.  The number of strings is defined
 * by the arguments.  The contents of the strings are not checked by the
 * renderer.
 *
 *	fields:	An array of strings with the name of the fields to be obtained.
 *	defaults:	An array of strings containing defalt values for the fields in order.
 *				This parameter can be null, meaning there are no defaults.  
 *				It can be an array that is not the same size as the fields array. If 
 *				the defaults array is longer than the fields array, the extra elements
 *				are ignored.  If the defaults array is shorter than the fields array, 
 *				then some of the fileds will have no default.
 *				A default value means the value to which the input field is initially 
 *				set.
 *
 *	The return value is either an array of strings or null.  A null value indicates
 * that the user cancelled the operation.  A non-null return value indicates that
 * the user accepted the operation.
 * The array is the same size as the fields array passed in.  It will contain the
 * strings obtained from the user.  Some or al of these values may be the passed 
 * defaults.
 */
public abstract String[] promptUserForStrings(String title, String[] fields, String[] defaults);
/**
 * Indicate to the renderer that something has changed requiring redisplay.
 *  If the value of recalculate is true, this means that the hierarchy of 
 * data has changed in a way that might require recalculation of the tree.
 */
public abstract void redisplay(boolean recalculate);
public abstract void removeModel(RenderableObject model);
public abstract void setSelectedMenu(java.awt.Menu menu);
public abstract void warning(String warningText);
}
